;Adobe Helvetica normal
;-------------------------------------------------
;Berechnet den nchsten Punkt eines Kreises
;-------------------------------------------------
;The result is the next point of a circle
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/LINIE.inc"
;%include "./INC/linie.inc"
;%include "./INC/outnc2.1.inc"

;buf			resb	25
;Deltax		dd	0		;Schritte X
;Deltay		dd	0		;Schritte Y
;Deltaz		dd	0		;Schritte Z
;Linex		dd	0		;Aktueller X-Wert der Linie
;Liney		dd	0		;Aktueller Y-Wert der Linie
;Linez		dd	0		;Aktueller Z-Wert der Linie

;Linedev		db	0		;Liniendefiniton
;Bit	2 1 0				X		Y		Z
;	0 0 0		nach		links+	vorne+	oben+
;	0 0 1		nach		rechts-	vorne+	oben+
;	0 1 0		nach		links+	hinten-	oben+
;	0 1 1		nach		rechts-	hinten-	oben+
;	1 0 0		nach		links+	vorne+	unten-
;	1 0 1		nach		rechts-	vorne+	unten-
;	1 1 0		nach		links+	hinten-	unten-
;	1 1 1		nach		rechts-	hinten-	unten-
;-------------------------------------------------

LINIE:
section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,14
	int	80h
	cmp	eax,14
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	dword[Linex],0
	mov	dword[Liney],0
	mov	dword[Linez],0
	mov	al,[buf]
	mov	ebx,0
	mov	[Linedev],al
	mov	eax,[buf+1]
	mov	[Deltax],eax
	add	ebx,eax
	mov	eax,[buf+5]
	mov	[Deltay],eax
	add	ebx,eax
	mov	eax,[buf+9]
	mov	[Deltaz],eax
	add	ebx,eax
	cmp	ebx,0
	jnz	.b
	jmp	.ende
.b:
	call	linie
	call	outnc
	mov	eax,[Deltax]
	cmp	eax,[Linex]
	jnz	.b
	mov	eax,[Deltay]
	cmp	eax,[Liney]
	jnz	.b
	mov	eax,[Deltaz]
	cmp	eax,[Linez]
	jnz	.b
.ende:
	mov	al,[buf+13]
	ret


