;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as
;	published by the Free Software Foundation.

;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU	General Public License for more details.
;	http://www.gnu.org/

;-------------------------------------------------
;%include "./INC/dokey.inc"
;%include "./INC/outnc2.3.inc"

;-------------------------------------------------

dokey:
section .text

	mov	ah,al
	sub	ah,0x60
	jnc	.a1
	jmp	.a8
.a1:
	cmp	al,0x77			;w
	jnz	.a2
	mov	byte[Bewegung],4	;y nach hinten
	mov	eax,0x4444
	call	error
	call	outnc
.a2:
	cmp	al,0x79			;y
	jnz	.a3
	mov	byte[Bewegung],8	;y nach vorne
	mov	eax,0x888
	call	error
	call	outnc
	jmp	.ende
.a3:
	cmp	al,0x61			;a
	jnz	.a4
	mov	byte[Bewegung],2	;x nach links
	mov	eax,0x222
	call	error
	call	outnc
	jmp	.ende
.a4:
	cmp	al,0x73			;s
	jnz	.a5
	mov	byte[Bewegung],1	;x nach rechts
	mov	eax,0x111
	call	error
	call	outnc
	jmp	.ende
.a5:
	cmp	al,0x65			;e
	jnz	.a6
	mov	byte[Bewegung],16	;z nach oben
	mov	eax,0x1616
	call	error
	call	outnc
	jmp	.ende
.a6:
	cmp	al,0x78			;x
	jnz	.a7
	mov	byte[Bewegung],32	;z nach unten
	mov	eax,0x3232
	call	error
	call	outnc
.a7:
	jmp	.ende

;-------------------------------------------------

.a8:
	mov	ah,al
	sub	ah,0x40
	jnc	.a9
	jmp	.a31
.a9:
	cmp	al,0x57			;shift-w
	jnz	.a11
	mov	byte[Bewegung],4	;y nach hinten
	mov	ecx,10
.a10:
	call	outnc
	loop	.a10
	jmp	.ende
.a11:
	cmp	al,0x59			;shift-y
	jnz	.a13
	mov	byte[Bewegung],8	;y nach vorne
	mov	ecx,10
.a12:
	call	outnc
	loop	.a12
	jmp	.ende
.a13:
	cmp	al,0x41			;shift-a
	jnz	.a15
	mov	byte[Bewegung],2	;x nach links
	mov	ecx,10
.a14:
	call	outnc
	loop	.a14
	jmp	.ende
.a15:
	cmp	al,0x53			;shift-s
	jnz	.a17
	mov	byte[Bewegung],1	;x nach rechts
	mov	ecx,10
.a16:
	call	outnc
	loop	.a16
	jmp	.ende
.a17:
	cmp	al,0x45			;shift-e
	jnz	.a19
	mov	byte[Bewegung],16	;z nach oben
	mov	ecx,10
.a18:
	call	outnc
	loop	.a18
	jmp	.ende
.a19:
	cmp	al,0x58			;shift-x
	jnz	.a21
	mov	byte[Bewegung],32	;z nach unten
	mov	ecx,10
.a20:
	call	outnc
	loop	.a20
.a21:
	jmp	.ende
;-------------------------------------------------

.a31:
	cmp	al,0x17			;strg-w
	jnz	.a33
	mov	byte[Bewegung],4	;y nach hinten
	mov	ecx,100
.a32:
	call	outnc
	loop	.a32
	jmp	.ende
.a33:
	cmp	al,0x19			;strg-y
	jnz	.a35
	mov	byte[Bewegung],8	;y nach vorne
	mov	ecx,100
.a34:
	call	outnc
	loop	.a34
	jmp	.ende
.a35:
	cmp	al,0x1			;strg-a
	jnz	.a37
	mov	byte[Bewegung],2	;x nach links
	mov	ecx,100
.a36:
	call	outnc
	loop	.a36
	jmp	.ende
.a37:
	cmp	al,0x13			;strg-s
	jnz	.a39
	mov	byte[Bewegung],1	;x nach rechts
	mov	ecx,100
.a38:
	call	outnc
	loop	.a38
	jmp	.ende
.a39:
	cmp	al,0x5			;strg-e
	jnz	.a41
	mov	byte[Bewegung],16	;z nach oben
	mov	ecx,100
.a40:
	call	outnc
	loop	.a40
	jmp	.ende
.a41:
	cmp	al,0x18			;strg-x
	jnz	.a43
	mov	byte[Bewegung],32	;z nach unten
	mov	ecx,100
.a42:
	call	outnc
	loop	.a42
	jmp	.ende
.a43:

.ende:
	ret