;Adobe Helvetica normal
;-------------------------------------------------
;Berechnet den nchsten Punkt eines Kreises
;stellt Bewegung fr den nchsten Schritt (outnc) 
;-------------------------------------------------
;The result is the next point of a circle
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/kreis-1.4.inc"
;%include "./INC/div64.inc"

;Kreisx		dd	0	;X-Wert auf der Kreislinie
;Kreisy		dd	0	;Y-Wert auf der Kreislinie
;Kreisz		dd	0	;Z-Wert auf der Kreislinie
;Radius		dd	0
;Bewegung		db	0	;wird so eingestellt,da ein call outnc
					;den berechneten Schritt ausfrt.

;kreisdev		db	0
;Bit	1 0
;	0 0		Kreis um die Z-Achse
;	0 1		Kreis um die Y-Achse
;	1 0		Kreis um die X-Achse
;	1 1		-

;Bit	2
;	0		linksrum
;	1		rechtsrum

;Bit 3=Wert der Achse 1|8 ist 0=(+), 1=(-)
;Bit 4=Wert der Achse 2|3 ist 0=(+), 1=(-)
;Bit	4 3
;	0 0		Kreissektor 1
;	0 1		Kreissektor 2
;	1 0		Kreissektor 4
;	1 1		Kreissektor 3

;Bit	5 4 3					changed !
;	0 0 0		Sektor  1
;	0 0 1		Sektor  4
;	0 1 0		Sektor  8
;	0 1 1		Sektor  5
;	1 0 0		Sektor  2
;	1 0 1		Sektor  3
;	1 1 0		Sektor  7
;	1 1 1		Sektor  6

;-------------------------------------------------

kreis:

section .text
	pushad

	cmp	dword[Radius],3031028437	;!!! Radius mu kleiner
	jb	.z
	jmp	.ende
.z:
	mov	edx,0
	mov	eax,[Radius]
	mul	dword[Radius]
	mov	[Wert],eax
	mov	[Wert+4],edx
	mov	bl,[kreisdev]
	and	bl,111000b

	cmp	bl,0					;Kreissektor  1   nein -> b
	jz	.a1
	jmp	 .b
.a1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.aa
	jmp	.a12
.aa:
;-------------------------------------------------Z-Achse 1	X-Y
;	mov	eax,0x10011111
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.a6
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y  nein -> a2
	ja	.a2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00100000b
	jmp	.ee					;springe zu Kreissektor  2 linksrum
.a2:
	call	.sector_z1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a4
	ja	.a4
	mov	byte[Bewegung],8
	jmp	.ende
.a4:
	mov	byte[Bewegung],9
	dec	dword[Kreisx]
	jmp	.ende
.a6:							;rechts um die Z-Achse
	cmp	dword[Kreisy],0			;ist y=0  nein -> a8
	jnz	.a8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00010000b
	jmp	.gg					;springe zu Kreissektor  8 rechtsrum
.a8:
	call	.sector_z1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a10
	jb	.a10
	mov	byte[Bewegung],4
	jmp	.ende
.a10:
	mov	byte[Bewegung],6
	inc	dword[Kreisx]
	jmp	.ende

.a12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.aa1
	jmp	.a24
.aa1:
;-------------------------------------------------Y-Achse 1	X-Z
;	mov	eax,0x01011111
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.a18
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a14
	ja	.a14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00100000b
	jmp	.ee1					;springe zu Kreissektor  2 linksrum
.a14:
	call	.sector_y1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a16
	ja	.a16
	mov	byte[Bewegung],16
	jmp	.ende
.a16:
	mov	byte[Bewegung],17
	dec	dword[Kreisx]
	jmp	.ende
.a18:							;rechts um die Y-Achse
	cmp	dword[Kreisz],0			;ist z=0  nein -> a20
	jnz	.a20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00010000b
	jmp	.gg1					;springe zu Kreissektor  8 Y-Achse rechtsrum
.a20:
	call	.sector_y1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a22
	jb	.a22
	mov	byte[Bewegung],32
	jmp	.ende
.a22:
	mov	byte[Bewegung],34
	inc	dword[Kreisx]
	jmp	.ende

.a24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.aa2
	jmp	.a36
.aa2:
;-------------------------------------------------X-Achse 1	Y-Z
;	mov	eax,0x00111111
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.a30
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a26
	ja	.a26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00100000b
	jmp	.ee2					;springe zu Kreissektor  2 links um die X-Achse
.a26:
	call	.sector_x1l
	cmp	ebx,eax				;ist yalt > yneu  ja -> a28
	ja	.a28
	mov	byte[Bewegung],16
	jmp	.ende
.a28:
	mov	byte[Bewegung],20
	dec	dword[Kreisy]
	jmp	.ende
.a30:							;rechts um die X-Achse
	cmp	dword[Kreisz],0			;ist z=0  nein -> a8
	jnz	.a32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00010000b
	jmp	.gg2					;springe zu Kreissektor  8 rechts um die X-Achse
.a32:
	call	.sector_x1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a34
	jb	.a34
	mov	byte[Bewegung],32
	jmp	.ende
.a34:
	mov	byte[Bewegung],40
	inc	dword[Kreisy]
	jmp	.ende
.a36:
	jmp	.ende

.b:
	cmp	bl,101000b				;Kreissektor  3   nein -> c
	jz	.b1
	jmp	.c
.b1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> b12
	jz	.bb
	jmp	.b12
.bb:
;-------------------------------------------------Z-Achse 3	X-Y
;	mov	eax,0x10033333
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> b6
	jnz	.b6
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y  nein -> b2
	jb	.b2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00001000b
	jmp	.ff					;springe zu Kreissektor 4 linksrum
.b2:
	call	.sector_z2r
	cmp	ebx,eax				;ist yalt > yneu  ja -> b4
	ja	.b4
	mov	byte[Bewegung],1
	jmp	.ende
.b4:
	mov	byte[Bewegung],5
	dec	dword[Kreisy]
	jmp	.ende
.b6:							;rechts um die Z-Achse
	cmp	dword[Kreisx],0			;ist x=0  nein -> b8
	jnz	.b8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00100000b
	jmp	.ee					;springe zu Kreissektor  2 rechtsrum
.b8:
	call	.sector_z2l
	cmp	ebx,eax				;ist yalt < yneu  ja -> b10
	jb	.b10
	mov	byte[Bewegung],2
	jmp	.ende
.b10:
	mov	byte[Bewegung],10
	inc	dword[Kreisy]
	jmp	.ende
.b12:
	cmp	bl,1					;um die Y-Achse  nein -> b24
	jz	.bb1
	jmp	.b24
.bb1:
;-------------------------------------------------Y-Achse 3	X-Z
;	mov	eax,0x01033333
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> b18
	jnz	.b18
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> b14
	jb	.b14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00001000b
	jmp	.ff1					;springe zu Kreissektor  4 linksrum
.b14:
	call	.sector_y2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> b16
	ja	.b16
	mov	byte[Bewegung],1
	jmp	.ende
.b16:
	mov	byte[Bewegung],33
	dec	dword[Kreisz]
	jmp	.ende
.b18:							;rechts um die Y-Achse
	cmp	dword[Kreisx],0			;ist x=0  nein -> b20
	jnz	.b20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00100000b
	jmp	.ee1					;springe zu Kreissektor  2 Y-Achse rechtsrum
.b20:
	call	.sector_y2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> b22
	jb	.b22
	mov	byte[Bewegung],2
	jmp	.ende
.b22:
	mov	byte[Bewegung],18
	inc	dword[Kreisz]
	jmp	.ende
.b24
	cmp	bl,2					;um die X-Achse  nein -> b36
	jz	.bb2
	jmp	.b36
.bb2:
;-------------------------------------------------X-Achse 3	Y-Z
;	mov	eax,0x00133333
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> b30
	jnz	.b30
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> b26
	jb	.b26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00001000b
	jmp	.ff2					;springe zu Kreissektor 4 links um die X-Achse
.b26:
	call	.sector_x2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> b28
	ja	.b28
	mov	byte[Bewegung],4
	jmp	.ende
.b28:
	mov	byte[Bewegung],36
	dec	dword[Kreisz]
	jmp	.ende
.b30:							;rechts um die X-Achse
	cmp	dword[Kreisy],0			;ist z=0  nein -> b32
	jnz	.b32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00100000b
	jmp	.ee2					;springe zu Kreissektor 2 rechts um die X-Achse
.b32:
	call	.sector_x2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> b34
	jb	.b34
	mov	byte[Bewegung],8
	jmp	.ende
.b34:
	mov	byte[Bewegung],24
	inc	dword[Kreisz]
	jmp	.ende
.b36:
	jmp	.ende


.c:
	cmp	bl,110000b				;Kreissektor  7   nein -> d
	jz	.c1
	jmp	.d
.c1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.cc
	jmp	.c12
.cc:
;-------------------------------------------------Z-Achse 7	X-Y
;	mov	eax,0x10077777
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.c6
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y  nein -> a2
	jb	.c2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00010000b
	jmp	.gg					;springe zu Kreissektor  8 linksrum
.c2:
	call	.sector_z2r
	cmp	ebx,eax				;ist yalt > yneu  ja -> a4
	ja	.c4
	mov	byte[Bewegung],2
	jmp	.ende
.c4:
	mov	byte[Bewegung],10
	dec	dword[Kreisy]
	jmp	.ende
.c6:							;rechts um die Z-Achse
	cmp	dword[Kreisx],0			;ist x=0  nein -> a8
	jnz	.c8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00111000b
	jmp	.hh					;springe zu Kreissektor 6 rechtsrum
.c8:
	call	.sector_z2l
	cmp	ebx,eax				;ist yalt < yneu  ja -> a10
	jb	.c10
	mov	byte[Bewegung],1
	jmp	.ende
.c10:
	mov	byte[Bewegung],5
	inc	dword[Kreisy]
	jmp	.ende
.c12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.cc1
	jmp	.c24
.cc1:
;-------------------------------------------------Y-Achse 7	X-Z
;	mov	eax,0x01077777
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.c18
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a14
	jb	.c14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00010000b
	jmp	.gg1					;springe zu Kreissektor  8 linksrum
.c14:
	call	.sector_y2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> a16
	ja	.c16
	mov	byte[Bewegung],2
	jmp	.ende
.c16:
	mov	byte[Bewegung],18
	dec	dword[Kreisz]
	jmp	.ende
.c18:							;rechts um die Y-Achse
	cmp	dword[Kreisx],0			;ist x=0  nein -> a20
	jnz	.c20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00111000b
	jmp	.hh1					;springe zu Kreissektor 6 rechtsrum
.c20:
	call	.sector_y2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> a22
	jb	.c22
	mov	byte[Bewegung],1
	jmp	.ende
.c22:
	mov	byte[Bewegung],33
	inc	dword[Kreisz]
	jmp	.ende
.c24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.cc2
	jmp	.c36
.cc2:
;-------------------------------------------------X-Achse 7	Y-Z
;	mov	eax,0x00177777
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.c30
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a26
	jb	.c26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00010000b
	jmp	.gg2					;springe zu Kreissektor 8 linksrum
.c26:
	call	.sector_x2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> a28
	ja	.c28
	mov	byte[Bewegung],8
	jmp	.ende
.c28:
	mov	byte[Bewegung],24
	dec	dword[Kreisz]
	jmp	.ende
.c30:							;rechts um die X-Achse
	cmp	dword[Kreisy],0			;ist y=0  nein -> a8
	jnz	.c32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00111000b
	jmp	.hh2					;springe zu Kreissektor  6 linksrum
.c32:
	call	.sector_x2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> a34
	jb	.c34
	mov	byte[Bewegung],4
	jmp	.ende
.c34:
	mov	byte[Bewegung],36
	inc	dword[Kreisz]
	jmp	.ende
.c36:
	jmp	.ende


.d:
	cmp	bl,011000b				;Kreissektor  5   nein -> e
	jz	.d1
	jmp	.e
.d1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.dd
	jmp	.d12
.dd:
;-------------------------------------------------Z-Achse 5	X-Y
;	mov	eax,0x10055555
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.d6
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y  nein -> a2
	ja	.d2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00111000b
	jmp	.hh					;springe zu Kreissektor  6 linksrum
.d2:
	call	.sector_z1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a4
	ja	.d4
	mov	byte[Bewegung],4
	jmp	.ende
.d4:
	mov	byte[Bewegung],6
	dec	dword[Kreisx]
	jmp	.ende
.d6:							;rechts um die Z-Achse
	cmp	dword[Kreisy],0			;ist y=0  nein -> a8
	jnz	.d8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00001000b
	jmp	.ff					;springe zu Kreissektor 4 rechtsrum
.d8:
	call	.sector_z1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a10
	jb	.d10
	mov	byte[Bewegung],8
	jmp	.ende
.d10:
	mov	byte[Bewegung],9
	inc	dword[Kreisx]
	jmp	.ende
.d12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.dd1
	jmp	.d24
.dd1:
;-------------------------------------------------Y-Achse 5	X-Z
;	mov	eax,0x01055555
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.d18
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a14
	ja	.d14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00111000b
	jmp	.hh1					;springe zu Kreissektor 6 linksrum
.d14:
	call	.sector_y1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a16
	ja	.d16
	mov	byte[Bewegung],32
	jmp	.ende
.d16:
	mov	byte[Bewegung],34
	dec	dword[Kreisx]
	jmp	.ende
.d18:							;rechts um die Y-Achse
	cmp	dword[Kreisz],0			;ist z=0  nein -> a20
	jnz	.d20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00001000b
	jmp	.ff1					;springe zu Kreissektor 4 rechtsrum
.d20:
	call	.sector_y1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a22
	jb	.d22
	mov	byte[Bewegung],16
	jmp	.ende
.d22:
	mov	byte[Bewegung],17
	inc	dword[Kreisx]
	jmp	.ende
.d24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.dd2
	jmp	.d36
.dd2:
;-------------------------------------------------X-Achse 5	Y-Z
;	mov	eax,0x00155555
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.d30
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a26
	ja	.d26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00111000b
	jmp	.hh2					;springe zu Kreissektor 6 links um die X-Achse
.d26:
	call	.sector_x1l
	cmp	ebx,eax				;ist yalt > yneu  ja -> a28
	ja	.d28
	mov	byte[Bewegung],32
	jmp	.ende
.d28:
	mov	byte[Bewegung],40
	dec	dword[Kreisy]
	jmp	.ende
.d30:							;rechts um die X-Achse
	cmp	dword[Kreisz],0			;ist z=0  nein -> a8
	jnz	.d32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00001000b
	jmp	.ff2					;springe zu Kreissektor 4 linksrum
.d32:
	call	.sector_x1r
	cmp	ebx,eax				;ist yalt < yneu  ja -> a34
	jb	.d34
	mov	byte[Bewegung],16
	jmp	.ende
.d34:
	mov	byte[Bewegung],20
	inc	dword[Kreisy]
	jmp	.ende
.d36:
	jmp	.ende


.e:
	cmp	bl,100000b				;Kreissektor  2   nein -> f
	jz	.e1
	jmp	.f
.e1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.ee
	jmp	.e12
.ee:
;-------------------------------------------------Z-Achse 2	X-Y
;	mov	eax,0x10022222
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.e6
	cmp	dword[Kreisx],0			;ist x=0  nein -> a2
	jnz	.e2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00101000b
	jmp	.bb					;springe zu Kreissektor 3 linksrum
.e2:
	call	.sector_z2l
	cmp	ebx,eax				;ist yalt < yneu  ja -> a4
	jb	.e4
	mov	byte[Bewegung],1
	jmp	.ende
.e4:
	mov	byte[Bewegung],9
	inc	dword[Kreisy]
	jmp	.ende
.e6:							;rechts um die Z-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y nein -> a8
	jb	.e8
	and	byte[kreisdev],11000111b
	jmp	.aa					;springe zu Kreissektor 1 rechtsrum
.e8:
	call	.sector_z2r
	cmp	ebx,eax				;ist yalt > yneu  ja -> a10
	ja	.e10
	mov	byte[Bewegung],2
	jmp	.ende
.e10:
	mov	byte[Bewegung],6
	dec	dword[Kreisy]
	jmp	.ende
.e12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.ee1
	jmp	.e24
.ee1:
;-------------------------------------------------Y-Achse 2	X-Z
;	mov	eax,0x01022222
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.e18
	cmp	dword[Kreisx],0			;ist x=0  nein -> a14
	jnz	.e14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00101000b
	jmp	.bb1					;springe zu Kreissektor 3 linksrum
.e14:
	call	.sector_y2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> a16
	jb	.e16
	mov	byte[Bewegung],1
	jmp	.ende
.e16:
	mov	byte[Bewegung],17
	inc	dword[Kreisz]
	jmp	.ende
.e18:							;rechts um die Y-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a20
	jb	.e20
	and	byte[kreisdev],11000111b
	jmp	.aa1					;springe zu Kreissektor 1 rechtsrum
.e20:
	call	.sector_y2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> a22
	ja	.e22
	mov	byte[Bewegung],2
	jmp	.ende
.e22:
	mov	byte[Bewegung],34
	dec	dword[Kreisz]
	jmp	.ende
.e24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.ee2
	jmp	.e36
.ee2:
;-------------------------------------------------X-Achse 2	Y-Z
;	mov	eax,0x00122222
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.e30
	cmp	dword[Kreisy],0			;ist z=0  nein -> a26
	jnz	.e26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00101000b
	jmp	.bb2					;springe zu Kreissektor 3 links um die X-Achse
.e26:
	call	.sector_x2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> a28
	jb	.e28
	mov	byte[Bewegung],4
	jmp	.ende
.e28:
	mov	byte[Bewegung],20
	inc	dword[Kreisz]
	jmp	.ende
.e30:							;rechts um die X-Achse
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a32
	jb	.e32
	and	byte[kreisdev],11000111b
	jmp	.aa2					;springe zu Kreissektor 1 rechtsrum
.e32:
	call	.sector_x2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> a34
	ja	.e34
	mov	byte[Bewegung],8
	jmp	.ende
.e34:
	mov	byte[Bewegung],40
	dec	dword[Kreisz]
	jmp	.ende
.e36:
	jmp	.ende
.f:
	cmp	bl,001000b				;Kreissektor  4   nein -> g
	jz	.f1
	jmp	.g
.f1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.ff
	jmp	.f12
.ff:
;-------------------------------------------------Z-Achse 4	X-Y
;	mov	eax,0x10044444
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.f6
	cmp	dword[Kreisy],0			;ist y=0  nein -> a2
	jnz	.f2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00011000b
	jmp	.dd					;springe zu Kreissektor 5 linksrum
.f2:
	call	.sector_z1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a4
	jb	.f4
	mov	byte[Bewegung],4
	jmp	.ende
.f4:
	mov	byte[Bewegung],5
	inc	dword[Kreisx]
	jmp	.ende
.f6:							;rechts um die Z-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y nein -> a8
	ja	.f8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00101000b
	jmp	.bb					;springe zu Kreissektor 3 rechtsrum
.f8:
	call	.sector_z1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a10
	ja	.f10
	mov	byte[Bewegung],8
	jmp	.ende
.f10:
	mov	byte[Bewegung],10
	dec	dword[Kreisx]
	jmp	.ende
.f12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.ff1
	jmp	.f24
.ff1:
;-------------------------------------------------Y-Achse 4	X-Z
;	mov	eax,0x01044444
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.f18
	cmp	dword[Kreisz],0			;ist z=0  nein -> a14
	jnz	.f14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00011000b
	jmp	.dd1					;springe zu Kreissektor 5 linksrum
.f14:
	call	.sector_y1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a16
	jb	.f16
	mov	byte[Bewegung],32
	jmp	.ende
.f16:
	mov	byte[Bewegung],33
	inc	dword[Kreisx]
	jmp	.ende
.f18:							;rechts um die Y-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a20
	ja	.f20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00101000b
	jmp	.bb1					;springe zu Kreissektor 3 rechtsrum
.f20:
	call	.sector_y1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a22
	ja	.f22
	mov	byte[Bewegung],16
	jmp	.ende
.f22:
	mov	byte[Bewegung],18
	dec	dword[Kreisx]
	jmp	.ende
.f24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.ff2
	jmp	.f36
.ff2:
;-------------------------------------------------X-Achse 4	Y-Z
;	mov	eax,0x00144444
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.f30
	cmp	dword[Kreisz],0			;ist z=0  nein -> a26
	jnz	.f26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00011000b
	jmp	.dd2					;springe zu Kreissektor 5 links um die X-Achse
.f26:
	call	.sector_x1r
	cmp	ebx,eax				;ist yalt < yneu  ja -> a28
	jb	.f28
	mov	byte[Bewegung],32
	jmp	.ende
.f28:
	mov	byte[Bewegung],36
	inc	dword[Kreisy]
	jmp	.ende
.f30:							;rechts um die X-Achse
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a32
	ja	.f32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00101000b
	jmp	.bb2					;springe zu Kreissektor 3 rechtsrum
.f32:
	call	.sector_x1l
	cmp	ebx,eax				;ist yalt > yneu  ja -> a34
	ja	.f34
	mov	byte[Bewegung],16
	jmp	.ende
.f34:
	mov	byte[Bewegung],24
	dec	dword[Kreisy]
	jmp	.ende
.f36:
	jmp	.ende

.g:
	cmp	bl,010000b				;Kreissektor 8   nein -> g
	jz	.g1
	jmp	.h
.g1:
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.gg
	jmp	.g12
.gg:
;-------------------------------------------------Z-Achse 8	X-Y
;	mov	eax,0x10088888
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.g6
	cmp	dword[Kreisy],0			;ist y=0  nein -> a2
	jnz	.g2
	and	byte[kreisdev],11000111b
	jmp	.aa					;springe zu Kreissektor 1 linksrum
.g2:
	call	.sector_z1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a4
	jb	.g4
	mov	byte[Bewegung],8
	jmp	.ende
.g4:
	mov	byte[Bewegung],10
	inc	dword[Kreisx]
	jmp	.ende
.g6:							;rechts um die Z-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y nein -> a8
	ja	.g8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00110000b
	jmp	.cc					;springe zu Kreissektor 7 rechtsrum
.g8:
	call	.sector_z1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a10
	ja	.g10
	mov	byte[Bewegung],4
	jmp	.ende
.g10:
	mov	byte[Bewegung],5
	dec	dword[Kreisx]
	jmp	.ende
.g12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.gg1
	jmp	.g24
.gg1:
;-------------------------------------------------Y-Achse 8	X-Z
;	mov	eax,0x01088888
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.g18
	cmp	dword[Kreisz],0			;ist z=0  nein -> a14
	jnz	.g14
	and	byte[kreisdev],11000111b
	jmp	.aa1					;springe zu Kreissektor 1 linksrum
.g14:
	call	.sector_y1r
	cmp	ebx,eax				;ist xalt < xneu  ja -> a16
	jb	.g16
	mov	byte[Bewegung],16
	jmp	.ende
.g16:
	mov	byte[Bewegung],18
	inc	dword[Kreisx]
	jmp	.ende
.g18:							;rechts um die Y-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a20
	ja	.g20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00110000b
	jmp	.cc1					;springe zu Kreissektor 7 rechtsrum
.g20:
	call	.sector_y1l
	cmp	ebx,eax				;ist xalt > xneu  ja -> a22
	ja	.g22
	mov	byte[Bewegung],32
	jmp	.ende
.g22:
	mov	byte[Bewegung],33
	dec	dword[Kreisx]
	jmp	.ende
.g24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.gg2
	jmp	.g36
.gg2:
;-------------------------------------------------X-Achse 8	Y-Z
;	mov	eax,0x00188888
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.g30
	cmp	dword[Kreisz],0			;ist z=0  nein -> a26
	jnz	.g26
	and	byte[kreisdev],11000111b
	jmp	.aa2					;springe zu Kreissektor 1 links um die X-Achse
.g26:
	call	.sector_x1r
	cmp	ebx,eax				;ist yalt < yneu  ja -> a28
	jb	.g28
	mov	byte[Bewegung],16
	jmp	.ende
.g28:
	mov	byte[Bewegung],24
	inc	dword[Kreisy]
	jmp	.ende
.g30:							;rechts um die X-Achse
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a32
	ja	.g32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00110000b
	jmp	.cc2					;springe zu Kreissektor 7 rechtsrum
.g32:
	call	.sector_x1l
	cmp	ebx,eax				;ist yalt > yneu  ja -> a34
	ja	.g34
	mov	byte[Bewegung],32
	jmp	.ende
.g34:
	mov	byte[Bewegung],36
	dec	dword[Kreisy]
	jmp	.ende
.g36:
	jmp	.ende


.h:							;Kreissektor 6
	mov	bl,[kreisdev]
	and	bl,11b
	cmp	bl,0					;um die Z-Achse  nein -> a12
	jz	.hh
	jmp	.h12
.hh:
;-------------------------------------------------Z-Achse 6	X-Y
;	mov	eax,0x10066666
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a6
	jnz	.h6
	cmp	dword[Kreisx],0			;ist x=0  nein -> a2
	jnz	.h2
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00110000b
	jmp	.cc					;springe zu Kreissektor 7 linksrum
.h2:
	call	.sector_z2l
	cmp	ebx,eax				;ist yalt < yneu  ja -> a4
	jb	.h4
	mov	byte[Bewegung],2
	jmp	.ende
.h4:
	mov	byte[Bewegung],6
	inc	dword[Kreisy]
	jmp	.ende
.h6:							;rechts um die Z-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisy]			;ist x=y nein -> a8
	jb	.h8
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00011000b
	jmp	.dd					;springe zu Kreissektor 5 rechtsrum
.h8:
	call	.sector_z2r
	cmp	ebx,eax				;ist yalt > yneu  ja -> a10
	ja	.h10
	mov	byte[Bewegung],1
	jmp	.ende
.h10:
	mov	byte[Bewegung],9
	dec	dword[Kreisy]
	jmp	.ende
.h12:
	cmp	bl,1					;um die Y-Achse  nein -> a24
	jz	.hh1
	jmp	.h24
.hh1:
;-------------------------------------------------Y-Achse 6	X-Z
;	mov	eax,0x01066666
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a18
	jnz	.h18
	cmp	dword[Kreisx],0			;ist x=0  nein -> a14
	jnz	.h14
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00110000b
	jmp	.cc1					;springe zu Kreissektor 7 linksrum
.h14:
	call	.sector_y2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> a16
	jb	.h16
	mov	byte[Bewegung],2
	jmp	.ende
.h16:
	mov	byte[Bewegung],34
	inc	dword[Kreisz]
	jmp	.ende
.h18:							;rechts um die Y-Achse
	mov	eax,[Kreisx]
	cmp	eax,[Kreisz]			;ist x=z  nein -> a20
	jb	.h20
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00011000b
	jmp	.dd1					;springe zu Kreissektor 5 rechtsrum
.h20:
	call	.sector_y2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> a22
	ja	.h22
	mov	byte[Bewegung],1
	jmp	.ende
.h22:
	mov	byte[Bewegung],17
	dec	dword[Kreisz]
	jmp	.ende
.h24
	cmp	bl,2					;um die X-Achse  nein -> a36
	jz	.hh2
	jmp	.h36
.hh2:
;-------------------------------------------------X-Achse 6	Y-Z
;	mov	eax,0x00166666
;	call	error
	test	byte[kreisdev],100b		;linksrum  nein -> a30
	jnz	.h30
	cmp	dword[Kreisy],0			;ist y=0  nein -> a26
	jnz	.h26
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00110000b
	jmp	.cc2					;springe zu Kreissektor 7 links um die X-Achse
.h26:
	call	.sector_x2l
	cmp	ebx,eax				;ist zalt < zneu  ja -> a28
	jb	.h28
	mov	byte[Bewegung],8
	jmp	.ende
.h28:
	mov	byte[Bewegung],40
	inc	dword[Kreisz]
	jmp	.ende
.h30:							;rechts um die X-Achse
	mov	eax,[Kreisy]
	cmp	eax,[Kreisz]			;ist y=z  nein -> a32
	jb	.h32
	and	byte[kreisdev],11000111b
	or	byte[kreisdev],00011000b
	jmp	.dd2					;springe zu Kreissektor 5 rechtsrum
.h32:
	call	.sector_x2r
	cmp	ebx,eax				;ist zalt > zneu  ja -> a34
	ja	.h34
	mov	byte[Bewegung],4
	jmp	.ende
.h34:
	mov	byte[Bewegung],20
	dec	dword[Kreisz]
	jmp	.ende
.h36:
.ende:
	popad
	ret
;-------------------------------------------------
.sector_z1l:
	inc	dword[Kreisy]
	mov	edx,0
	mov	eax,[Kreisy]
	mul	dword[Kreisy]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisx]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_z2l:
	dec	dword[Kreisx]
	mov	edx,0
	mov	eax,[Kreisx]
	mul	dword[Kreisx]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisy]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_z1r:
	dec	dword[Kreisy]
	mov	edx,0
	mov	eax,[Kreisy]
	mul	dword[Kreisy]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisx]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_z2r:
	inc	dword[Kreisx]
	mov	edx,0
	mov	eax,[Kreisx]
	mul	dword[Kreisx]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisy]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_y1l:
	inc	dword[Kreisz]
	mov	edx,0
	mov	eax,[Kreisz]
	mul	dword[Kreisz]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisx]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_y2l:
	dec	dword[Kreisx]
	mov	edx,0
	mov	eax,[Kreisx]
	mul	dword[Kreisx]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisz]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_y1r:
	dec	dword[Kreisz]
	mov	edx,0
	mov	eax,[Kreisz]
	mul	dword[Kreisz]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisx]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_y2r:
	inc	dword[Kreisx]
	mov	edx,0
	mov	eax,[Kreisx]
	mul	dword[Kreisx]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisz]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_x1l:
	inc	dword[Kreisz]
	mov	edx,0
	mov	eax,[Kreisz]
	mul	dword[Kreisz]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisy]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_x2l:
	dec	dword[Kreisy]
	mov	edx,0
	mov	eax,[Kreisy]
	mul	dword[Kreisy]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisz]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_x1r:
	dec	dword[Kreisz]
	mov	edx,0
	mov	eax,[Kreisz]
	mul	dword[Kreisz]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisy]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret

.sector_x2r:
	inc	dword[Kreisy]
	mov	edx,0
	mov	eax,[Kreisy]
	mul	dword[Kreisy]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	mov	ebx,[Kreisz]
	mov	[Teiler],ebx
	mov	dword[Teiler+4],0
	call	div64
	mov	eax,[Ergebnis]
	ret
