; pcnc - Copyright (C) 2004 Sebastian Beck <sebastian.bw@freenet.de>
;NC-Software fr die HSE Elektronik.


section .data

msg		db	'Steuerung beendet',10
lmsg		equ	$-msg

t1		db	' Das System wird jetzt gesperrt !',10,\
			' Haben Sie alles Abgespeichert, fals das System sich aufhngt ?',10,\
			' Sie knnen das Frsprogramm wrend der Arbeit mit der Taste "B" abbrechen.',10,\
			' Jetzt Starten -> RETURN.',10,0
lt1		equ	$-t1

datname		db	'nc.tmp',0
nameschleifdat	db	's.tmp',0

schleifdat		dd	0		;Dateinummer zur Speicherung der Schleifen
priority		dd	0		;max priority
Sekunden		dd	0		;0 - 2147483648
Millisekunden	dd	100000000	;0 - 999 999 999
saveint		db	0		;Maskregister sichern
Key			dw	0
Bewegung		db	1
Delay			dd	200000
X			dd	1000000000	;Werkstck-X-Position
Y			dd	1000000000	;Werkstck-Y-Position
Z			dd	1000000000	;Werkstck-Z-Position
Kreisx		dd	0		;X-Wert auf der Kreislinie
Kreisy		dd	0		;Y-Wert auf der Kreislinie
Kreisz		dd	0		;Z-Wert auf der Kreislinie
Radius		dd	0
kreisdev		db	0
Wert			dd	0,0		;value	-unchanged
Teiler			dd	0,0		;divider	-unchanged
Ergebnis		dd	0,0		;result
Ellipsx		dd	0		;X-Wert auf der Ellipse
Ellipsy		dd	0		;Y-Wert auf der Ellipse
Ellipsz		dd	0		;Z-Wert auf der Ellipse
Akreisx		dd	0		;X-Wert auf dem Auenkreis
Akreisy		dd	0		;Y-Wert auf dem Auenkreis
Akreisz		dd	0		;Z-Wert auf dem Auenkreis
Radius1		dd	0		;Innenkreis
Radius2		dd	0		;Auen
Sector		dd	0		;45-Tangenten-Schnittpunktes
ellipsdev		db	0
Deltax		dd	0		;Lnge X
Deltay		dd	0		;Lnge Y
Deltaz		dd	0		;Lnge Z
Linex			dd	0		;Aktueller X-Wert der Linie
Liney			dd	0		;Aktueller Y-Wert der Linie
Linez			dd	0		;Aktueller Z-Wert der Linie
Linedev		db	0		;Liniendefiniton
Spielx			db	5		;Spiel der X-Achse
Spiely			db	5		;Spiel der Y-Achse
Spielz			db	0		;Spiel der Z-Achse - fr Rundtisch
Praezision		dd	0		;Unterbrechung fr SCHLEIFE
datnum		dd	0		;Dateinummer
Deltaellips		dd	0,0		;=die Vernderung von Ellipsx,Ellipsy nach einer Przision
Deltakreis		dd	0,0		;=die Vernderung von Kreisx,Kreisy nach einer Przision
Delta			dd	0,0		;=die Vernderung

section .bss
buf			resb	30		;Puffer fr die Befehlskette aus der Datei


section .text
global _start                      		;must be declared for linker (ld)

%include "./INC/div64.inc"
%include "./INC/Taste.inc"
%include "./INC/kreis-1.4.inc"
%include "./INC/sleep.inc"
%include "./INC/sqrt64.inc"
%include "./INC/makekreisdev.inc"
%include "./INC/linie.inc"
%include "./INC/outnc-2.7.inc"
%include "./INC/KREIS.inc"
%include "./INC/LINIE.inc"
%include "./INC/LINIEX.inc"
%include "./INC/LINIEY.inc"
%include "./INC/LINIEZ.inc"
%include "./INC/SCHLEIFE.inc"
%include "./INC/WARTE.inc"
%include "./INC/SPIEL.inc"
%include "./INC/verteiler.inc"
%include "./INC/STEUERUNG.inc"
%include "./INC/dokey.inc"
%include "./INC/VORSCHUB.inc"
%include "./INC/stdout.inc"
%include "./INC/writexyz.inc"
%include "./INC/error.inc"
%include "./INC/error1.inc"
%include "./INC/makesys.inc"
%include "./INC/clearsys.inc"
%include "./INC/warte.inc"
%include "./INC/WERKZEUGWECHSEL.inc"
%include "./INC/MEMO.inc"

_start:

	call	makesys		;macht alle Vorbereitungen
a:
	call	verteiler		;Haupschleife
ende:
	call	clearsys		;System wieder herstellen
	mov	edx,lmsg
	mov	ecx,msg
	mov	ebx,1
	mov	eax,4
	int	$80

	mov	eax,1
	int	$80
;-------------------------------------
